SystemOrganization addCategory: #Plotter!
SystemOrganization addCategory: #'Plotter-lineSegments'!
SystemOrganization addCategory: #'Plotter-histogram'!
SystemOrganization addCategory: #'Plotter-morph'!

!Float methodsFor: '*Plotter' stamp: 'HwaJong 1/9/2013 14:32'!
adjustedForPlotterTick
	|rounded|
	rounded := self roundTo: 0.01.
	rounded fractionPart < 0.02
		ifTrue: [^rounded integerPart].
	rounded fractionPart > 0.98
		ifTrue: [^rounded >= 0 ifTrue: [rounded integerPart+1] ifFalse: [rounded integerPart-1]].
	^rounded! !

!Integer methodsFor: '*Plotter' stamp: 'HwaJong 1/9/2013 14:34'!
adjustedForPlotterTick
	^self! !

Morph subclass: #PlotterMorph
	instanceVariableNames: 'form plotter drawsForm drawsPlotting drawingMode bisect'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Plotter-morph'!

!PlotterMorph methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/18/2012 17:26'!
controlledByBisect: aNumber
	plotter controlledByBisect: aNumber.
	self changed! !

!PlotterMorph methodsFor: 'drawing' stamp: 'HwaJong 12/21/2012 01:10'!
drawOn: aCanvas
	super drawOn: aCanvas.
	[
	drawingMode drawsForm
		ifTrue: 
			[ form ifNotNil: [aCanvas paintImage: form at: self position]].
	drawingMode drawsPlotter
		ifTrue: 
			[
				aCanvas 
				translateBy: self position 
				during: 
					[:canvas| 
					plotter drawOn: (drawingMode blendingPlot
							ifTrue: [(AlphaBlendingCanvas on: canvas) alpha: 0.3]
							ifFalse: [canvas]) ].
			]
		
	] on: Error 
			do: [:e| Transcript cr; print: e; flush ]! !

!PlotterMorph methodsFor: 'initialize' stamp: 'HwaJong 1/8/2013 15:22'!
initialize 
	super initialize.
	drawingMode := PMDMPlotOnly new.
	self initializePlotter.! !

!PlotterMorph methodsFor: 'initialize' stamp: 'HwaJong 12/20/2012 15:25'!
initializePlotter
	"plotter := HistogramPlotter new."! !

!PlotterMorph methodsFor: 'accessing' stamp: 'HwaJong 12/18/2012 16:52'!
plotter: aPlotter 
	plotter := aPlotter! !

!PlotterMorph methodsFor: 'changing' stamp: 'HwaJong 12/20/2012 00:32'!
showFormOnly
	drawingMode := PMDMFormOnly new.
	self changed.! !

!PlotterMorph methodsFor: 'changing' stamp: 'HwaJong 12/20/2012 00:42'!
showPlotterOverForm
	drawingMode := PMDMPlotOverForm new.
	self changed.! !

!PlotterMorph methodsFor: 'changing' stamp: 'HwaJong 12/20/2012 00:33'!
showPlottingOnly
	drawingMode := PMDMPlotOnly new.
	self changed.! !

!Fraction methodsFor: '*Plotter' stamp: 'HwaJong 1/9/2013 14:32'!
adjustedForPlotterTick
	^self asFloat adjustedForPlotterTick! !

Object subclass: #GaussianBellCurve
	instanceVariableNames: 'mean standardDeviation gain'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Plotter-histogram'!

!GaussianBellCurve methodsFor: 'self evaluating' stamp: 'HwaJong 12/18/2012 23:05'!
denom
	^(2 * Float pi) sqrt * standardDeviation! !

!GaussianBellCurve methodsFor: 'drawing' stamp: 'HwaJong 12/20/2012 14:16'!
drawOn: aCanvas plotter: aPlotter
	| op |
	op := aPlotter pixelPointAtPixelX: (aPlotter xAxis pixelStart) onFunctionObject: self.
	^ aPlotter xAxis pixelStart to: aPlotter xAxis pixelEnd do: [ :px | 
		| p |
		p := aPlotter pixelPointAtPixelX: px onFunctionObject: self.
		aCanvas line: op to: p color: Color blue.
		op := p ]! !

!GaussianBellCurve methodsFor: 'accessing' stamp: 'HwaJong 12/18/2012 23:46'!
gain
	^gain ifNil: [1] ifNotNil: [gain]! !

!GaussianBellCurve methodsFor: 'accessing' stamp: 'HwaJong 12/18/2012 23:46'!
gain: aNumber
	gain := aNumber! !

!GaussianBellCurve methodsFor: 'accessing' stamp: 'HwaJong 12/18/2012 22:47'!
mean
	^ mean! !

!GaussianBellCurve methodsFor: 'accessing' stamp: 'HwaJong 12/18/2012 22:47'!
mean: aNumber
	mean := aNumber
! !

!GaussianBellCurve methodsFor: 'self evaluating' stamp: 'HwaJong 12/18/2012 23:05'!
normalizedX: aNumber
	^(aNumber - mean) / standardDeviation! !

!GaussianBellCurve methodsFor: 'accessing' stamp: 'HwaJong 12/18/2012 22:47'!
standardDeviation
	^ standardDeviation! !

!GaussianBellCurve methodsFor: 'accessing' stamp: 'HwaJong 12/18/2012 22:47'!
standardDeviation: aNumber
	standardDeviation := aNumber
! !

!GaussianBellCurve methodsFor: 'self evaluating' stamp: 'HwaJong 12/18/2012 23:46'!
value: aNumber
	^((self normalizedX: aNumber) squared / -2) exp / self denom * self gain! !

Object subclass: #HistoBar
	instanceVariableNames: 'startX endX tally'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Plotter-histogram'!

!HistoBar class methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/19/2012 00:57'!
startX: sx endX: ex tally: t
	^ self new
		startX: sx;
		endX: ex;
		tally: t! !

!HistoBar methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/20/2012 14:30'!
drawOn: aCanvas plotter: aPlotter
	| px py px2 py2 p1 p2 |
	p1 := aPlotter pixelPointOfValuePoint: startX @ tally.
	p2 := aPlotter pixelPointOfValuePoint: endX @ 0.
	aCanvas fillRectangle: (p1 corner: p2) color: Color gray! !

!HistoBar methodsFor: 'accessing' stamp: 'HwaJong 12/19/2012 00:48'!
endX
	^ endX! !

!HistoBar methodsFor: 'accessing' stamp: 'HwaJong 12/19/2012 00:48'!
endX: aNumber
	endX := aNumber
! !

!HistoBar methodsFor: 'accessing' stamp: 'HwaJong 12/19/2012 00:48'!
startX
	^ startX! !

!HistoBar methodsFor: 'accessing' stamp: 'HwaJong 12/19/2012 00:48'!
startX: aNumber
	startX := aNumber
! !

!HistoBar methodsFor: 'accessing' stamp: 'HwaJong 12/19/2012 00:48'!
tally
	^ tally! !

!HistoBar methodsFor: 'accessing' stamp: 'HwaJong 12/19/2012 00:48'!
tally: aNumber
	tally := aNumber
! !

!Object methodsFor: '*Plotter' stamp: 'HwaJong 1/9/2013 15:16'!
printStringForPlotterTick
	|str fp|
	str := self adjustedForPlotterTick printString.
	fp := str indexOf: $..
	^fp < 1 
		ifTrue: [str] 
		ifFalse: [
			str size > (fp+2)
				ifTrue: [str first: fp+2]
				ifFalse: [str]].! !

Object subclass: #PMDrawingMode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Plotter-morph'!

PMDrawingMode subclass: #PMDMFormOnly
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Plotter-morph'!

!PMDMFormOnly methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/20/2012 00:24'!
blendingPlot
	^false! !

!PMDMFormOnly methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/20/2012 00:24'!
drawsForm
	^true! !

!PMDMFormOnly methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/20/2012 00:24'!
drawsPlotter
	^false! !

PMDrawingMode subclass: #PMDMPlotOnly
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Plotter-morph'!

!PMDMPlotOnly methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/20/2012 00:35'!
blendingPlot
	^false! !

!PMDMPlotOnly methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/20/2012 00:33'!
drawsForm
	^false! !

!PMDMPlotOnly methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/20/2012 00:34'!
drawsPlotter
	^true! !

PMDrawingMode subclass: #PMDMPlotOverForm
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Plotter-morph'!

!PMDMPlotOverForm methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/20/2012 00:36'!
blendingPlot
	^true! !

!PMDMPlotOverForm methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/20/2012 00:35'!
drawsForm
	^true! !

!PMDMPlotOverForm methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/20/2012 00:36'!
drawsPlotter
	^true! !

Object subclass: #PlotLineSegments
	instanceVariableNames: 'points color'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Plotter-lineSegments'!

PlotLineSegments subclass: #CrossDecoratedPlotLineSegments
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Plotter-lineSegments'!

!CrossDecoratedPlotLineSegments methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/21/2012 16:21'!
drawOn: aCanvas plotter: aPlotter
	
	2 to: self points size do: [:k|
		aCanvas line: (aPlotter pixelPointOfValuePoint: (self points at: k-1)) to: (aPlotter pixelPointOfValuePoint: (self points at: k)) width: self lineWidth color: self color.
		].
	self points do: [ :p |
		| pp |
		pp := aPlotter pixelPointOfValuePoint: p.
		aCanvas line: (pp x - 1 @ pp y - 3) to: (pp x + 1 @ pp y + 3) width: 2 color: self color.
		aCanvas line: ((pp x - 3) @ (pp y + 3)) to: ((pp x + 3) @ (pp y - 3)) width: 2 color: self color
		]
	! !

!CrossDecoratedPlotLineSegments methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/21/2012 15:50'!
lineWidth
	^1! !

PlotLineSegments subclass: #DashedPlotLineSegments
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Plotter-lineSegments'!

!DashedPlotLineSegments methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/8/2013 16:25'!
drawOn: aCanvas plotter: aPlotter
	2 to: self points size do: [:k|
		aCanvas line: (aPlotter pixelPointOfValuePoint: (self points at: k-1)) to: (aPlotter pixelPointOfValuePoint: (self points at: k)) width: self lineWidth color: self color dashLength: 6 secondColor: Color transparent secondDashLength: 3 startingOffset: 0 
		].
	! !

!DashedPlotLineSegments methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/21/2012 16:29'!
lineWidth
	^1! !

!PlotLineSegments methodsFor: 'self evaluating' stamp: 'HwaJong 1/9/2013 14:12'!
collectX
	^points collect: #x! !

!PlotLineSegments methodsFor: 'self evaluating' stamp: 'HwaJong 1/9/2013 14:13'!
collectY
	^points collect: #y! !

!PlotLineSegments methodsFor: 'accessing' stamp: 'HwaJong 1/9/2013 11:19'!
color
	^color setDefault: #defaultColor for: self withSetter: #color:! !

!PlotLineSegments methodsFor: 'accessing' stamp: 'HwaJong 1/9/2013 11:20'!
color: aColor
	color := aColor! !

!PlotLineSegments methodsFor: 'self evaluating' stamp: 'HwaJong 1/9/2013 11:19'!
defaultColor
	^Color black! !

!PlotLineSegments methodsFor: 'self evaluating' stamp: 'HwaJong 1/9/2013 14:13'!
maxX
	^self collectX max! !

!PlotLineSegments methodsFor: 'self evaluating' stamp: 'HwaJong 1/9/2013 14:13'!
maxY
	^self collectY max ! !

!PlotLineSegments methodsFor: 'self evaluating' stamp: 'HwaJong 1/9/2013 14:13'!
minX
	^self collectX min! !

!PlotLineSegments methodsFor: 'self evaluating' stamp: 'HwaJong 1/9/2013 14:13'!
minY
	^self collectY min! !

!PlotLineSegments methodsFor: 'accessing' stamp: 'HwaJong 12/21/2012 16:30'!
points
	^ points! !

!PlotLineSegments methodsFor: 'accessing' stamp: 'HwaJong 12/21/2012 16:30'!
points: arrayOfPoints
	points := arrayOfPoints
! !

PlotLineSegments subclass: #StrongPlotLineSegments
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Plotter-lineSegments'!

!StrongPlotLineSegments methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/21/2012 15:27'!
drawOn: aCanvas plotter: aPlotter
	
	2 to: self points size do: [:k|
		aCanvas line: (aPlotter pixelPointOfValuePoint: (self points at: k-1)) to: (aPlotter pixelPointOfValuePoint: (self points at: k)) width: self lineWidth color: self color.
		].
	! !

!StrongPlotLineSegments methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/21/2012 15:11'!
lineWidth
	^3! !

Object subclass: #PlotTick
	instanceVariableNames: 'tickValue axis'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Plotter'!

PlotTick subclass: #LinePlotTick
	instanceVariableNames: 'counterAxis'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Plotter'!

!LinePlotTick methodsFor: 'accessing' stamp: 'HwaJong 12/21/2012 14:26'!
counterAxis
	^ counterAxis! !

!LinePlotTick methodsFor: 'accessing' stamp: 'HwaJong 12/21/2012 14:26'!
counterAxis: aPlotterAxis 
	counterAxis := aPlotterAxis
! !

!LinePlotTick methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/9/2013 14:32'!
drawForHorizontalPlotterAxisOn: aCanvas
	| pt lineFrom lineTo tickLabelPosition |
	pt := axis mapper map: self tickValue.
	lineFrom := pt @ counterAxis pixelStart.
	lineTo := pt @ counterAxis pixelEnd.
	aCanvas line: lineFrom to: lineTo color: (axis color lighter lighter lighter lighter lighter lighter lighter lighter lighter).
	
	tickLabelPosition := ((pt-((axis tickFont widthOfStringOrText: self tickValue printStringForPlotterTick)/2)) @ (lineTo y+6)).
	aCanvas 
		drawString: self tickValue printStringForPlotterTick
		at: tickLabelPosition
		font: axis tickFont 
		color: axis color! !

!LinePlotTick methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/9/2013 14:33'!
drawForVerticalPlotterAxisOn: aCanvas
	| pt lineFrom lineTo tickLabelPosition  |
	pt := axis mapper map: self tickValue.
	lineFrom := counterAxis pixelStart @ pt.
	lineTo := counterAxis pixelEnd @ pt.
	aCanvas line: lineFrom to: lineTo color: axis color lighter lighter lighter lighter lighter lighter lighter lighter lighter.
	tickLabelPosition := (((lineFrom x)-(axis tickFont widthOfStringOrText: self tickValue printStringForPlotterTick)-16) @ (pt-(axis tickFont height/2))).
	
	aCanvas 
		drawString: self tickValue printStringForPlotterTick
		at: tickLabelPosition
		font: axis tickFont 
		color: axis color
! !

!PlotTick methodsFor: 'accessing' stamp: 'HwaJong 12/21/2012 14:08'!
axis
	^ axis! !

!PlotTick methodsFor: 'accessing' stamp: 'HwaJong 12/21/2012 14:08'!
axis: aPlotterAxis 
	axis := aPlotterAxis
! !

!PlotTick methodsFor: 'accessing' stamp: 'HwaJong 12/21/2012 13:57'!
tickValue
	^tickValue! !

!PlotTick methodsFor: 'accessing' stamp: 'HwaJong 12/21/2012 13:57'!
tickValue: aFloat 
	tickValue := aFloat! !

PlotTick subclass: #SimplePlotTick
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Plotter'!

!SimplePlotTick methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/21/2012 14:29'!
counterAxis: aPlotterAxis
	^self! !

!SimplePlotTick methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/9/2013 14:33'!
drawForHorizontalPlotterAxisOn: aCanvas
	| pt lineFrom lineTo tickLabelPosition each |
	each := self tickValue.
	pt := axis mapper map: each.
	lineFrom := pt @ axis fixedPixel.
	lineTo := pt @ (axis fixedPixel+5).
	aCanvas line: lineFrom to: lineTo color: axis color.
	tickLabelPosition := ((pt-((axis tickFont widthOfStringOrText: each printStringForPlotterTick)/2)) @ (lineTo y)).
	aCanvas 
		drawString: each printStringForPlotterTick
		at: tickLabelPosition
		font: axis tickFont 
		color: axis color! !

!SimplePlotTick methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/9/2013 14:33'!
drawForVerticalPlotterAxisOn: aCanvas
	| pt lineFrom lineTo tickLabelPosition  |
	pt := axis mapper map: self tickValue.
	lineFrom := axis fixedPixel @ pt.
	lineTo := (axis fixedPixel-5) @ pt.
	aCanvas line: lineFrom to: lineTo color: axis color.
	tickLabelPosition := (((lineTo x)-(axis tickFont widthOfStringOrText: self tickValue printStringForPlotterTick)) @ (pt-(axis tickFont height/2))).
	
	aCanvas 
		drawString: self tickValue printStringForPlotterTick
		at: tickLabelPosition
		font: axis tickFont 
		color: axis color
! !

Object subclass: #Plotter
	instanceVariableNames: 'xAxis yAxis title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Plotter'!

Plotter subclass: #HistogramPlotter
	instanceVariableNames: 'gaussian bars'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Plotter-histogram'!

!HistogramPlotter methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/19/2012 00:03'!
controlledByBisect: aNumber
	gaussian mean: aNumber! !

!HistogramPlotter methodsFor: 'drawing' stamp: 'HwaJong 12/20/2012 00:42'!
drawOn: aCanvas
	xAxis drawOn: aCanvas.
	yAxis drawOn: aCanvas.
	bars do: [:bar| bar drawOn: aCanvas plotter: self].
	gaussian drawOn: aCanvas plotter: self.
	aCanvas drawString: title at: (self titlePosition) font: (self titleFont) color: (Color black).! !

!HistogramPlotter methodsFor: 'initialize-release' stamp: 'HwaJong 12/21/2012 14:37'!
initialize 
	super initialize.
	self title: 'BATTERY LIFETIMES (YEARS)'.
	self initializeGaussian.
	self initializeBars.
! !

!HistogramPlotter methodsFor: 'initialize-release' stamp: 'HwaJong 12/19/2012 17:32'!
initializeBars
	bars := {
		HistoBar startX: 2.5 endX: 3.0 tally: 4. 
		HistoBar startX: 2.0 endX: 2.5 tally: 1.
		HistoBar startX: 1.5 endX: 2.0 tally: 2.
		HistoBar startX: 3.0 endX: 3.5 tally: 15.
		HistoBar startX: 3.5 endX: 4.0 tally: 10.
		HistoBar startX: 4.0 endX: 4.5 tally: 5.
		HistoBar startX: 4.5 endX: 5.0 tally: 3.}.
! !

!HistogramPlotter methodsFor: 'initialize-release' stamp: 'HwaJong 12/19/2012 17:31'!
initializeGaussian
	gaussian := 
		GaussianBellCurve new 
			mean: 3.413818359375; 
			standardDeviation: 0.6999999105930328;
			gain: 26.1328125.
! !

!HistogramPlotter methodsFor: 'initialize-release' stamp: 'HwaJong 12/21/2012 13:48'!
initializeXAxis
	xAxis := 
		HorizontalPlotterAxis new
			fixedPixel: 460;
			pixelStart: 62;
			pixelEnd: 669;
			valueStart: 0.0 valueEnd: 6.0;
			ticks: ((0.0 to: 6.0 by: 0.5) collect: [:each| SimplePlotTick new tickValue: each]).
! !

!HistogramPlotter methodsFor: 'initialize-release' stamp: 'HwaJong 12/21/2012 13:49'!
initializeYAxis
	yAxis := 
		VerticalPlotterAxis new
			fixedPixel: 62;
			pixelStart: 58;
			pixelEnd: 460;
			valueStart: 16.0 valueEnd: 0.0;
			ticks: ((0 to: 16 by: 2) collect: [:each| SimplePlotTick new tickValue: each]);
			title: 'FREQUENCY'.
! !

!HistogramPlotter methodsFor: 'mapping' stamp: 'HwaJong 12/20/2012 14:15'!
pixelPointAtPixelX: px onFunctionObject: function
	| py vx |
	vx := self xAxis mapper unmap: px.
	py := self yAxis mapper map: (function value: vx).
	^ px @ py! !

!HistogramPlotter methodsFor: 'mapping' stamp: 'HwaJong 12/20/2012 13:06'!
pixelPointOfValuePoint: aPoint
	^(xAxis mapper map: aPoint x) @ (yAxis mapper map: aPoint y)! !

!HistogramPlotter methodsFor: 'self evaluating' stamp: 'HwaJong 12/19/2012 19:58'!
titleFont
	^StrikeFont familyName:  #DefaultTextStyle pointSize: 12 emphasized: 0! !

!HistogramPlotter methodsFor: 'self evaluating' stamp: 'HwaJong 12/19/2012 20:03'!
titlePosition
	^((xAxis pixelStart) + ((xAxis pixelEnd - xAxis pixelStart) - (self titleFont widthOfStringOrText: title))/2.0)@21! !

!HistogramPlotter methodsFor: 'mapping' stamp: 'HwaJong 12/20/2012 13:07'!
valuePointOfPixelPoint: aPoint
	^(xAxis mapper unmap: aPoint x) @ (yAxis mapper unmap: aPoint y)! !

Plotter subclass: #LinesPlotter
	instanceVariableNames: 'lineSegments'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Plotter-lineSegments'!

!LinesPlotter class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/8/2013 15:30'!
exampleLinesPlotter
	|x y l |
	x := HorizontalPlotterAxis new
			fixedPixel: 492;
			pixelStart: 74;
			pixelEnd: 682;
			mapper: 
				(MultiRangeMapper newWithAssociations: 
					{0.1->74.0.
					2->170.
					5->212.
					10->249.
					20->294.
					30->327.
					40->353.
					50->378.
					60->405.
					70->432.
					80->465.
					90->508.
					95->545.
					98->588.
					99->615.0.
					99.9->682.0});
			ticks: ({0.1. 2. 5. 10. 20. 30. 40. 50. 60. 70. 80. 90. 95. 98. 99. 99.9} collect: [:each| LinePlotTick new tickValue: each]).
	y := 
		VerticalPlotterAxis new
			fixedPixel: 73;
			pixelStart: 48;
			pixelEnd: 493;
			valueStart: 170.0 valueEnd: 50.0;
			ticks: ((50 to: 170 by: 10) collect: [:each| LinePlotTick new tickValue: each]).
	l := {
		StrongPlotLineSegments new
			points: {
				8@63.
				97@152
			}. 
		DashedPlotLineSegments new 
			points: {
				16@52.
				50@88.
				83@105
			}. 
		DashedPlotLineSegments new 
			points: {
				16@97.
				50@114.
				84@150
			}. 
		CrossDecoratedPlotLineSegments new
			points: {
				7.5 @71.8.
				17.5 @77.8.
				22 @81.5.
				29.5 @81.6.
				38 @91.
				42 @92.
				47 @95.
				51 @97.
				56 @104.
				61 @109.
				66 @110.
				72 @122.
				77 @123.
				84 @130.
				92 @148.
				97 @149.
			}
		}.
	^self new
		xAxis: x yAxis: y;
		lineSegments: l! !

!LinesPlotter class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/9/2013 11:24'!
exampleNumberArray
	^self numberArrays: 
		{#(120 122 124 126 128 130 132 134 136 138 140 142 144 146 148 150 152 154 156 158 160 162 164 166 168 169 170 171 172 173). #(120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149). #(120 122 124 126 128 130 132 134 136 138 140 142 144 146 148 150 152 154 156 158 160 162 164 166 168 170 172 174 176 178 120 122)}! !

!LinesPlotter class methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/9/2013 14:02'!
lineSegments: lineSegments
	|x y minX maxX minY maxY|
	
	minX := (lineSegments collect: #minX) min.
	maxX := (lineSegments collect: #maxX) max.
	
	minY := (lineSegments collect: #minY) min.
	maxY := (lineSegments collect: #maxY) max.
	
	x := HorizontalPlotterAxis new
			title: 'x';
			fixedPixel: 460;
			pixelStart: 62;
			pixelEnd: 669;
			valueStart: minX valueEnd: maxX;
			ticks: ((minX to: maxX by: (maxX-minX)/5) collect: [:each| SimplePlotTick new tickValue: each]).
	y := 
		VerticalPlotterAxis new
			title: 'y';
			fixedPixel: 62;
			pixelStart: 48;
			pixelEnd: 460;
			valueStart: maxY valueEnd: minY;
			ticks: ((minY to: maxY by: (maxY-minY)/6) collect: [:each| SimplePlotTick new tickValue: each]).
	^self new
		xAxis: x yAxis: y;
		lineSegments: lineSegments! !

!LinesPlotter class methodsFor: 'as yet unclassified' stamp: 'HwaJong 6/27/2013 20:51'!
numberArrays: array2d
	|na x y l colors mx mn xmax|
	colors := {Color red. Color green. Color blue. Color orange}.
	na := array2d.
	x := HorizontalPlotterAxis new
			title: 'index';
			fixedPixel: 460;
			pixelStart: 62;
			pixelEnd: 669;
			valueStart: 1 valueEnd: (xmax := (na collect: #size) max);
			ticks: ({1. xmax//4. xmax//2. xmax*3//4. xmax} collect: [:each| SimplePlotTick new tickValue: each]).
	mn := (na collect: #min) min*0.9.
	mx := (na collect: #max) max*1.1.
	y := 
		VerticalPlotterAxis new
			title: 'value';
			fixedPixel: 62;
			pixelStart: 48;
			pixelEnd: 460;
			valueStart: mx valueEnd: mn;
			ticks: ({mn. (((mn*3)+(mx))//4). (mn+mx)//2. (((mn)+(mx*3))//4). mx} collect: [:each| SimplePlotTick new tickValue: each]).
	l := (1 to: na size) collect: [:naIndex| 
			|array|
			array := na at: naIndex.
			DashedPlotLineSegments new 
				color: (colors at: naIndex);
				points: (array keysAndValuesCollect: [:index :value| index@value])].
	^self new
		xAxis: x yAxis: y;
		lineSegments: l! !

!LinesPlotter methodsFor: 'as yet unclassified' stamp: 'HwaJong 12/20/2012 17:15'!
controlledByBisect: aNumber
	xAxis pixelStart: aNumber! !

!LinesPlotter methodsFor: 'drawing' stamp: 'HwaJong 12/21/2012 15:08'!
drawOn: aCanvas
	xAxis drawOn: aCanvas.
	yAxis drawOn: aCanvas.
	self lineSegments do: [:ls| ls drawOn: aCanvas plotter: self].
	title ifNotNil: 
		[aCanvas drawString: title at: (self titlePosition) font: (self titleFont) color: (Color black)].! !

!LinesPlotter methodsFor: 'initialize-release' stamp: 'HwaJong 12/21/2012 13:59'!
initializeXAxis
	xAxis := 
		HorizontalPlotterAxis new
			fixedPixel: 492;
			pixelStart: 74;
			pixelEnd: 682;
			mapper: 
				(MultiRangeMapper newWithAssociations: 
					{0.1->74.0.
					2->170.
					5->212.
					10->249.
					20->294.
					30->327.
					40->353.
					50->378.
					60->405.
					70->432.
					80->465.
					90->508.
					95->545.
					98->588.
					99->615.0.
					99.9->682.0});
			ticks: ({0.1. 2. 5. 10. 20. 30. 40. 50. 60. 70. 80. 90. 95. 98. 99. 99.9} collect: [:each| LinePlotTick new tickValue: each]).
! !

!LinesPlotter methodsFor: 'initialize-release' stamp: 'HwaJong 12/21/2012 13:59'!
initializeYAxis
	yAxis := 
		VerticalPlotterAxis new
			fixedPixel: 73;
			pixelStart: 48;
			pixelEnd: 493;
			valueStart: 170.0 valueEnd: 50.0;
			ticks: ((50 to: 170 by: 10) collect: [:each| LinePlotTick new tickValue: each]).
! !

!LinesPlotter methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/8/2013 15:29'!
lineSegments
	^lineSegments! !

!LinesPlotter methodsFor: 'accessing' stamp: 'HwaJong 1/8/2013 15:30'!
lineSegments: anArray 
	lineSegments := anArray! !

!LinesPlotter methodsFor: 'mapping' stamp: 'HwaJong 12/20/2012 15:25'!
pixelPointAtPixelX: px onFunctionObject: function
	| py vx |
	vx := self xAxis mapper unmap: px.
	py := self yAxis mapper map: (function value: vx).
	^ px @ py! !

!LinesPlotter methodsFor: 'mapping' stamp: 'HwaJong 12/20/2012 15:25'!
pixelPointOfValuePoint: aPoint
	^(xAxis mapper map: aPoint x) @ (yAxis mapper map: aPoint y)! !

!LinesPlotter methodsFor: 'self evaluating' stamp: 'HwaJong 12/20/2012 15:25'!
titleFont
	^StrikeFont familyName:  #DefaultTextStyle pointSize: 12 emphasized: 0! !

!LinesPlotter methodsFor: 'self evaluating' stamp: 'HwaJong 12/20/2012 15:25'!
titlePosition
	^((xAxis pixelStart) + ((xAxis pixelEnd - xAxis pixelStart) - (self titleFont widthOfStringOrText: title))/2.0)@21! !

!LinesPlotter methodsFor: 'mapping' stamp: 'HwaJong 12/20/2012 15:25'!
valuePointOfPixelPoint: aPoint
	^(xAxis mapper unmap: aPoint x) @ (yAxis mapper unmap: aPoint y)! !

!Plotter methodsFor: 'as yet unclassified' stamp: 'HwaJong 1/8/2013 15:26'!
initialize 
	super initialize.! !

!Plotter methodsFor: 'initialize-release' stamp: 'HwaJong 12/21/2012 14:38'!
relateTicksAndAxis
	xAxis ticks do: [:each| each axis: xAxis; counterAxis: yAxis].
	yAxis ticks do: [:each| each axis: yAxis; counterAxis: xAxis].! !

!Plotter methodsFor: 'accessing' stamp: 'HwaJong 12/21/2012 14:35'!
title
	^ title! !

!Plotter methodsFor: 'accessing' stamp: 'HwaJong 12/21/2012 14:35'!
title: aString
	title := aString
! !

!Plotter methodsFor: 'accessing' stamp: 'HwaJong 12/21/2012 14:35'!
xAxis
	^xAxis! !

!Plotter methodsFor: 'accessing' stamp: 'HwaJong 1/8/2013 15:26'!
xAxis: plotterAxisX yAxis: plotterAxisY
	xAxis := plotterAxisX.
	yAxis := plotterAxisY.
	self relateTicksAndAxis.! !

!Plotter methodsFor: 'accessing' stamp: 'HwaJong 12/21/2012 14:35'!
yAxis
	^yAxis! !

Object subclass: #PlotterAxis
	instanceVariableNames: 'ticks pixelStart pixelEnd mapper fixedPixel'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Plotter'!

PlotterAxis subclass: #HorizontalPlotterAxis
	instanceVariableNames: 'title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Plotter'!

!HorizontalPlotterAxis methodsFor: 'drawing' stamp: 'HwaJong 1/8/2013 15:51'!
drawOn: aCanvas
	aCanvas line: self pixelStart @ self fixedPixel to: self pixelEnd @ self fixedPixel color: self color.
	self drawTicksOn: aCanvas.
	self drawTitleOn: aCanvas.! !

!HorizontalPlotterAxis methodsFor: 'drawing' stamp: 'HwaJong 12/21/2012 14:22'!
drawTicksOn: aCanvas
	self ticks do: [:spt | 
		spt drawForHorizontalPlotterAxisOn: aCanvas].! !

!HorizontalPlotterAxis methodsFor: 'drawing' stamp: 'HwaJong 1/8/2013 15:52'!
drawTitleOn: aCanvas
	title ifNil: [^self].
	aCanvas drawString: title at: (self titlePosition) font: (self titleFont) color: (self color)! !

!HorizontalPlotterAxis methodsFor: 'self evaluating' stamp: 'HwaJong 12/19/2012 18:59'!
tickFont
	^StrikeFont familyName:  #DefaultTextStyle pointSize: 7 emphasized: 0! !

!HorizontalPlotterAxis methodsFor: 'accessing' stamp: 'HwaJong 1/8/2013 15:50'!
title
	^ title! !

!HorizontalPlotterAxis methodsFor: 'accessing' stamp: 'HwaJong 1/8/2013 15:50'!
title: aString
	title := aString
! !

!HorizontalPlotterAxis methodsFor: 'self evaluating' stamp: 'HwaJong 1/8/2013 15:52'!
titleFont
	^StrikeFont familyName:  #DefaultTextStyle pointSize: 9 emphasized: 0! !

!HorizontalPlotterAxis methodsFor: 'self evaluating' stamp: 'HwaJong 1/8/2013 16:04'!
titleOffset
	^((pixelEnd - pixelStart) - self titleWidth)/2.0! !

!HorizontalPlotterAxis methodsFor: 'self evaluating' stamp: 'HwaJong 1/8/2013 16:01'!
titlePosition
	^(self titleOffset)@(fixedPixel+ 20)! !

!HorizontalPlotterAxis methodsFor: 'self evaluating' stamp: 'HwaJong 1/8/2013 15:52'!
titleWidth
	^self titleFont widthOfStringOrText: title! !

!PlotterAxis methodsFor: 'accessing' stamp: 'HwaJong 12/21/2012 12:42'!
color
	^Color black! !

!PlotterAxis methodsFor: 'accessing' stamp: 'HwaJong 12/21/2012 13:24'!
fixedPixel
	^ fixedPixel! !

!PlotterAxis methodsFor: 'accessing' stamp: 'HwaJong 12/21/2012 13:24'!
fixedPixel: aNumber
	fixedPixel := aNumber
! !

!PlotterAxis methodsFor: 'accessing' stamp: 'HwaJong 12/21/2012 12:40'!
mapper
	^mapper! !

!PlotterAxis methodsFor: 'accessing' stamp: 'HwaJong 12/21/2012 12:37'!
mapper: anObject
	mapper := anObject! !

!PlotterAxis methodsFor: 'accessing' stamp: 'HwaJong 12/20/2012 23:52'!
pixelEnd
	^pixelEnd! !

!PlotterAxis methodsFor: 'accessing' stamp: 'HwaJong 12/20/2012 23:52'!
pixelEnd: aSmallInteger 
	pixelEnd := aSmallInteger ! !

!PlotterAxis methodsFor: 'accessing' stamp: 'HwaJong 12/20/2012 23:52'!
pixelStart
	^pixelStart! !

!PlotterAxis methodsFor: 'accessing' stamp: 'HwaJong 12/20/2012 23:52'!
pixelStart: aSmallInteger 
	pixelStart := aSmallInteger! !

!PlotterAxis methodsFor: 'accessing' stamp: 'HwaJong 12/21/2012 13:54'!
ticks
	^ ticks! !

!PlotterAxis methodsFor: 'accessing' stamp: 'HwaJong 12/21/2012 13:54'!
ticks: arrayOfNumbers
	ticks := arrayOfNumbers.
! !

!PlotterAxis methodsFor: 'initialize-release' stamp: 'HwaJong 12/21/2012 13:06'!
valueStart: aFloat valueEnd: aFloat2 
	mapper := RangeMapper from: (Range from: aFloat to: aFloat2) to: (Range from: pixelStart to: pixelEnd)! !

PlotterAxis subclass: #VerticalPlotterAxis
	instanceVariableNames: 'title'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Plotter'!

!VerticalPlotterAxis methodsFor: 'drawing' stamp: 'HwaJong 12/21/2012 13:22'!
drawOn: aCanvas
	aCanvas line: self fixedPixel @ self pixelStart to: self fixedPixel @ self pixelEnd color: self color.
	self drawTicksOn: aCanvas.
	self drawTitleOn: aCanvas.! !

!VerticalPlotterAxis methodsFor: 'drawing' stamp: 'HwaJong 12/21/2012 16:36'!
drawTicksOn: aCanvas
	self ticks do: [:spt | 
		spt drawForVerticalPlotterAxisOn: aCanvas].! !

!VerticalPlotterAxis methodsFor: 'drawing' stamp: 'HwaJong 12/21/2012 01:20'!
drawTitleOn: aCanvas
	title ifNil: [^self].
	aCanvas 
		transformBy: (MatrixTransform2x3 withAngle: -90) 
		clippingTo: (0@0 extent: 500@500) 
		during: [:canvas | 
			canvas drawString: title at: (self titlePosition) font: (self titleFont) color: (self color)]
		smoothing: 2.! !

!VerticalPlotterAxis methodsFor: 'self evaluating' stamp: 'HwaJong 12/19/2012 18:58'!
tickFont
	^StrikeFont familyName:  #DefaultTextStyle pointSize: 7 emphasized: 0! !

!VerticalPlotterAxis methodsFor: 'accessing' stamp: 'HwaJong 12/19/2012 19:44'!
title
	^ title! !

!VerticalPlotterAxis methodsFor: 'accessing' stamp: 'HwaJong 12/19/2012 19:44'!
title: aString
	title := aString
! !

!VerticalPlotterAxis methodsFor: 'self evaluating' stamp: 'HwaJong 12/19/2012 19:28'!
titleFont
	^StrikeFont familyName:  #DefaultTextStyle pointSize: 9 emphasized: 0! !

!VerticalPlotterAxis methodsFor: 'self evaluating' stamp: 'HwaJong 12/19/2012 19:46'!
titleOffset
	^((pixelEnd - pixelStart) - self titleWidth)/2.0! !

!VerticalPlotterAxis methodsFor: 'self evaluating' stamp: 'HwaJong 12/19/2012 19:49'!
titlePosition
	^(pixelEnd - self titleOffset) negated @18! !

!VerticalPlotterAxis methodsFor: 'self evaluating' stamp: 'HwaJong 12/19/2012 19:45'!
titleWidth
	^self titleFont widthOfStringOrText: title! !
